## thinkfan 0.6.6

=== Makefile ===
# Yep. Really trying to stick with minimalism...

.DEFAULT_GOAL := thinkfan

thinkfan:	system.o config.o thinkfan.o
			gcc $(CFLAGS) -Wall -o thinkfan system.o config.o thinkfan.o
			
system.o:	system.c system.h message.h globaldefs.h
			gcc $(CFLAGS) -Wall -c system.c

config.o:	config.c config.h message.h globaldefs.h system.h
			gcc $(CFLAGS) -Wall -c config.c

thinkfan.o:	thinkfan.c thinkfan.h message.h globaldefs.h config.h
			gcc -DMAKEFILE $(CFLAGS) -Wall -c thinkfan.c

clean:
		rm *.o thinkfan

## thinkfan 0.7.1

=== Makefile ===
# Yep. Really trying to stick with minimalism...

.DEFAULT_GOAL := thinkfan

thinkfan:	system.o parser.o config.o thinkfan.o
			gcc $(CFLAGS) -Wall -o thinkfan system.o config.o parser.o \
			thinkfan.o
			
system.o:	system.c system.h message.h globaldefs.h parser.h
			gcc $(CFLAGS) -Wall -c system.c

config.o:	config.c config.h message.h globaldefs.h system.h parser.h
			gcc $(CFLAGS) -Wall -c config.c

thinkfan.o:	thinkfan.c thinkfan.h message.h globaldefs.h config.h
			gcc $(CFLAGS) -Wall -c thinkfan.c

clean:
		rm -rf *.o thinkfan

## thinkfan 0.7.3

=== Makefile ===
--- 
+++ 
@@ -1,11 +1,12 @@
-# Yep. Really trying to stick with minimalism...
-
 .DEFAULT_GOAL := thinkfan
 
-thinkfan:	system.o parser.o config.o thinkfan.o
+thinkfan:	system.o parser.o config.o thinkfan.o message.o
 			gcc $(CFLAGS) -Wall -o thinkfan system.o config.o parser.o \
-			thinkfan.o
-			
+			thinkfan.o message.o
+
+message.o:	message.c globaldefs.h
+			gcc $(CFLAGS) -Wall -c message.c
+
 system.o:	system.c system.h message.h globaldefs.h parser.h
 			gcc $(CFLAGS) -Wall -c system.c

## thinkfan 0.8.0

=== debian/changelog ===
thinkfan (0.8.0-1) unstable; urgency=low

  * Imported Upstream version 0.8.0
  * do not override dh_auto_clean
  * Standards-Version: 3.9.3
  * use dh 9 for hardening flags
  * switch to source format 3.0 (quilt)
  * use CPPFLAGS in the Makefile
  * do not use $(< ...) in the systemd file

 -- Evgeni Golov <evgeni@debian.org>  Wed, 06 Jun 2012 21:36:00 +0200

thinkfan (0.8~alpha2-1) experimental; urgency=low

  [ Mika Pflüger ]
  * New Upstream release.
    + Adds complex rule format with individual limits for every
      sensor.
    + Levels can now be given as strings like "level auto" if
      desired.
  * debian/rules:
    + Adapt file paths to new upstream version.
  * Drop systemd service file from debian/, upstream ships it.

  [ Evgeni Golov ]
  * Upload to experimental.
    Closes: #660293
    Thanks: Mika Pflüger <debian@mikapflueger.de>

 -- Evgeni Golov <evgeni@debian.org>  Sat, 18 Feb 2012 09:44:18 +0100

thinkfan (0.7.3-1) unstable; urgency=low

  * New upstream release.
    + Don't cut buffer to length 8 in setfan_ibm().
      Closes: #610722
  * Update debian/copyright:
    + Update years.
    + thinkfan is now GPLv3 licensed.
    + Update to latest dep5 spec.
  * Standards-Version: 3.9.2
  * Add systemd service file.
    Thanks: Michael Stapelberg <michael+db20090501@stapelberg.de>
    Closes: #635750

 -- Evgeni Golov <evgeni@debian.org>  Sun, 09 Oct 2011 20:23:45 +0200

thinkfan (0.7.1-2) unstable; urgency=high

  * debian/control:
    + Add missing Vcs-* fields for Git.
    + Standards-Version: 3.9.1
  * debian/rules:
    + Install upstreams init-scripts. (Closes: #592321)

 -- Evgeni Golov <evgeni@debian.org>  Tue, 10 Aug 2010 11:55:10 +0200

thinkfan (0.7.1-1) unstable; urgency=low

  * New upstream release.
  * debian/control:
    + Fix typo (temerature → temperature).
      Closes: #566382
    + Update description according to upstream's README.
    + Standards-Version: 3.9.0
  * debian/copyright:
    + Quote BSD-license, thanks lintian.

 -- Evgeni Golov <evgeni@debian.org>  Thu, 15 Jul 2010 18:24:27 +0200

thinkfan (0.7-1) unstable; urgency=low

  * New upstream release
  * debian/thinkfan{1,manpages}:
    + Use upstream's manpage instead of our own.
  * debian/README.source:
    + Remove README.source as upstream ships .tar.gz now.
  * debian/control:
    + Standards-Version: 3.8.4
  * debian/copyright:
    + Update upstream's copyright years.
    + Update Gentoo init-script path.
  * debian/thinkfan.{default,init}:
    + Upstream ships our init-scripts, drop them from debian/.
  * debian/thinkfan.examples:
    + Ship upstream's example configs under /u/s/d/thinkfan/examples/.
  * debian/source/format:
    + Add debian/source/format telling it's still a 1.0 package,
      thanks lintian.
  * debian/thinkfan.docs:
    + Include upstream's NEWS file.

 -- Evgeni Golov <evgeni@debian.org>  Wed, 07 Apr 2010 19:52:26 +0200

thinkfan (0.6.6-1) unstable; urgency=low

  * New upstream release
  * debian/rules:
    + Install thinkfan.conf.thinkpad as /etc/thinkfan.conf.
    + Do not override build target, upstream's one is fine.
  * debian/copyright:
    + Update to DEP5 revision 135.
    + Update my copyright years.
  * debian/watch:
    + Upstream started to use gzipped tar files, fix the link.

 -- Evgeni Golov <evgeni@debian.org>  Sun, 03 Jan 2010 19:11:05 +0100

thinkfan (0.6~rc1-1) unstable; urgency=low

  * New upstream release
    + Includes the "pulsing-fan workaround".
      Closes: #546762 
  * debian/README.Debian, debian/thinkfan.default:
    + Describe necessity for fan_control=1 for thinkpad_acpi.
      Closes: #547701
  * debian/thinkfan.default:
    + Let the user adjust DAEMON_ARGS, so he can pass own parameters.
  * debian/thinkfan.1:
    + Update the manpage to reflect the new -p parameter.

 -- Evgeni Golov <evgeni@debian.org>  Mon, 09 Nov 2009 11:53:11 +0100

thinkfan (0.5.0.1-1) unstable; urgency=low

  * Initial release (Closes: #537573)

 -- Evgeni Golov <evgeni@debian.org>  Wed, 02 Sep 2009 14:12:49 +0200

## thinkfan 0.8.1

=== Makefile ===
# Now this is still minimalistic ;-)

.DEFAULT_GOAL := thinkfan

CC ?= gcc

thinkfan:	system.o parser.o config.o thinkfan.o message.o
		$(CC) $(LDFLAGS) -Wall -o $@ $^

%.o:	%.c
		$(CC) $(CFLAGS) -Wall -c -o $@ $<

clean:
		rm -rf *.o thinkfan

=== debian/changelog ===
thinkfan (0.8.1-1) unstable; urgency=low

  * Imported Upstream version 0.8.1
    + Does not write "level X" to sysfs anymore.
      Closes: #684315

 -- Evgeni Golov <evgeni@debian.org>  Mon, 13 Aug 2012 07:09:37 +0200

=== debian/control ===
Source: thinkfan
Section: misc
Priority: extra
Maintainer: Evgeni Golov <evgeni@debian.org>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.3
Homepage: http://sourceforge.net/projects/thinkfan/
Vcs-Git: git://git.debian.org/users/evgeni/thinkfan.git
Vcs-Browser: http://git.debian.org/?p=users/evgeni/thinkfan.git

Package: thinkfan
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: simple and lightweight fan control program
 Some hardware has a kind of broken fan-control and lets the fan run
 faster than really needed. Thinkfan will prevent this by controlling
 the fan on its own (the fan speed for each temperature interval can be
 adjusted in the configuration file).
 .
 Originally designed specifically for IBM/Lenovo Thinkpads,
 it supports any kind of system via the sysfs hwmon interface.
 It is designed to eat as little CPU power as possible.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_install:
	install -D -m0755 thinkfan $(CURDIR)/debian/thinkfan/usr/sbin/thinkfan
	install -D -m0644 examples/thinkfan.conf.thinkpad $(CURDIR)/debian/thinkfan/etc/thinkfan.conf
	install -D -m0755 rcscripts/thinkfan.init $(CURDIR)/debian/thinkfan/etc/init.d/thinkfan
	install -D -m0644 rcscripts/thinkfan.default $(CURDIR)/debian/thinkfan/etc/default/thinkfan
	install -D -m0644 rcscripts/thinkfan.service $(CURDIR)/debian/thinkfan/lib/systemd/system/thinkfan.service

override_dh_installinit:
	dh_installinit --onlyscripts

## thinkfan 0.9.2

=== CMakeLists.txt ===
project(thinkfan)

cmake_minimum_required(VERSION 2.6)

option(USE_ATASMART "Enable reading temperatures from HDDs via S.M.A.R.T")
set(MAXERR 2 CACHE STRING "Fail after this many consecutive errors when in DANGEROUS
mode")

add_executable(thinkfan thinkfan.c config.c message.c parser.c system.c)

set(CMAKE_C_FLAGS_DEBUG "-O0 -g3 -Wall -DDEBUG")

if(NOT DEFINED CMAKE_C_FLAGS)
	set(CMAKE_C_FLAGS "-O3 -Wall")
endif(NOT DEFINED CMAKE_C_FLAGS)

if(MAXERR)
	set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -DMAXERR=${MAXERR}")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DMAXERR=${MAXERR}")
endif(MAXERR)

if(USE_ATASMART)
	set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -DUSE_ATASMART")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DUSE_ATASMART")
	target_link_libraries(thinkfan atasmart)
endif(USE_ATASMART)

install(TARGETS thinkfan DESTINATION sbin)
install(FILES NEWS COPYING README examples/thinkfan.conf.complex
	examples/thinkfan.conf.simple DESTINATION share/doc/thinkfan)
install(FILES thinkfan.1 DESTINATION share/man/man1)

=== debian/changelog ===
thinkfan (0.9.2-1) unstable; urgency=medium

  * Imported Upstream version 0.9.2

 -- Evgeni Golov <evgeni@debian.org>  Tue, 29 Apr 2014 07:54:46 +0200

thinkfan (0.9.1-1) experimental; urgency=medium

  [ Evgeni Golov ]
  * Imported Upstream version 0.9.1
    + Uses $MAINPID in the systemd unit. (Closes: #713876)
  * Add B-D on cmake
  * Rework packaging after the switch to cmake.
  * use canonical git urls
  * Standards-Version: 3.9.5
  * patch CMakeFiles.txt to install stuff to expected locations

  [ Michael Stapelberg ]
  * use dh-systemd for proper systemd-related maintscripts (Closes: #713878)
  * document how to use thinkfan with systemd (Closes: #728087)

 -- Evgeni Golov <evgeni@debian.org>  Sun, 27 Apr 2014 00:22:49 +0200

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: misc
 Priority: extra
 Maintainer: Evgeni Golov <evgeni@debian.org>
-Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.3
+Build-Depends: debhelper (>= 9), dh-systemd (>= 1.3), cmake
+Standards-Version: 3.9.5
 Homepage: http://sourceforge.net/projects/thinkfan/
-Vcs-Git: git://git.debian.org/users/evgeni/thinkfan.git
-Vcs-Browser: http://git.debian.org/?p=users/evgeni/thinkfan.git
+Vcs-Git: git://anonscm.debian.org/users/evgeni/thinkfan.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/evgeni/thinkfan.git
 
 Package: thinkfan
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --with=systemd

override_dh_auto_install:
	dh_auto_install
	rm $(CURDIR)/debian/thinkfan/usr/share/doc/thinkfan/thinkfan.conf.*
	rm $(CURDIR)/debian/thinkfan/usr/share/doc/thinkfan/COPYING
	install -D -m0644 examples/thinkfan.conf.simple $(CURDIR)/debian/thinkfan/etc/thinkfan.conf
	install -D -m0755 rcscripts/thinkfan.init $(CURDIR)/debian/thinkfan/etc/init.d/thinkfan
	install -D -m0644 rcscripts/thinkfan.default $(CURDIR)/debian/thinkfan/etc/default/thinkfan
	install -D -m0644 rcscripts/thinkfan.service $(CURDIR)/debian/thinkfan/lib/systemd/system/thinkfan.service

override_dh_installinit:
	dh_installinit --onlyscripts

override_dh_systemd_enable:
	# Do not enable the file by default on purpose.
	# The user should enable it only after making sure the configuration is
	# appropriate for his/her computer.
	# This corresponds to START=no in /etc/default/thinkfan

=== debian/watch ===
version=3
opts="uversionmangle=s/_/~/" \
 http://sf.net/thinkfan/thinkfan-([\d\._]+)\.tar\.gz

## thinkfan 0.9.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 set(MAXERR 2 CACHE STRING "Fail after this many consecutive errors when in DANGEROUS
 mode")
 
-add_executable(thinkfan thinkfan.c config.c message.c parser.c system.c)
+add_executable(thinkfan src/thinkfan.c src/config.c src/message.c src/parser.c src/system.c)
 
 set(CMAKE_C_FLAGS_DEBUG "-O0 -g3 -Wall -DDEBUG")

=== debian/changelog ===
thinkfan (0.9.3-2) unstable; urgency=medium

  * call update-rc.d thinkfan disable on fresh installs (Closes: #758579)
  * migrate old installations to a properly disabled sysv service too
  * drop the old START param from the init script and defaults file
  * update docs on enabling the service under sysvinit
  * load daemon args from /e/d/thinkfan when using systemd too (Closes: #850514)

 -- Evgeni Golov <evgeni@debian.org>  Fri, 17 Mar 2017 15:56:43 +0100

thinkfan (0.9.3-1) unstable; urgency=medium

  * Imported Upstream version 0.9.3
    + Closes: #823710
  * Standards-Version: 3.9.8
  * enable SMART support (Closes: #747143)
  * update Homepage field
  * update d/copyright
  * update d/watch for github
  * fix manpage installation
  * add AppStream support (Closes: #840595)
  * move to collab-maint
  * call dh_systemd_enable --no-enable

 -- Evgeni Golov <evgeni@debian.org>  Fri, 30 Dec 2016 15:52:36 +0100

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: misc
 Priority: extra
 Maintainer: Evgeni Golov <evgeni@debian.org>
-Build-Depends: debhelper (>= 9), dh-systemd (>= 1.3), cmake
-Standards-Version: 3.9.5
-Homepage: http://sourceforge.net/projects/thinkfan/
-Vcs-Git: git://anonscm.debian.org/users/evgeni/thinkfan.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/evgeni/thinkfan.git
+Build-Depends: debhelper (>= 9), dh-systemd (>= 1.3), cmake, libatasmart-dev
+Standards-Version: 3.9.8
+Homepage: https://github.com/vmatare/thinkfan
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/thinkfan.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/thinkfan.git
 
 Package: thinkfan
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,8 @@
 %:
 	dh $@ --with=systemd
 
+override_dh_auto_configure:
+	dh_auto_configure -- -DUSE_ATASMART=YES
 override_dh_auto_install:
 	dh_auto_install
 	rm $(CURDIR)/debian/thinkfan/usr/share/doc/thinkfan/thinkfan.conf.*
@@ -19,3 +21,4 @@
 	# The user should enable it only after making sure the configuration is
 	# appropriate for his/her computer.
 	# This corresponds to START=no in /etc/default/thinkfan
+	dh_systemd_enable --no-enable

=== debian/watch ===
version=4
opts="uversionmangle=s/_/~/,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
 https://github.com/vmatare/thinkfan/tags \
 (?:.*?/)?v?(\d.*)\.tar\.gz debian uupdate

## thinkfan 1.2.1

=== CMakeLists.txt ===
project(thinkfan)
include(GNUInstallDirs)

cmake_minimum_required(VERSION 3.0)

# Generate absolute paths or something
cmake_policy(SET CMP0015 NEW)

find_package(PkgConfig)
find_package(Threads)
pkg_check_modules(SYSTEMD "systemd")
pkg_check_modules(OPENRC "openrc")

pkg_check_modules(YAML_CPP "yaml-cpp")

if(YAML_CPP_FOUND AND YAML_CPP_VERSION VERSION_LESS "0.5.3")
	message(WARNING "yaml-cpp version ${YAML_CPP_VERSION} is very old, buggy and lacks some features. Thinkfan will not always be able to point out the location of errors in the YAML config.")
	add_definitions(-DHAVE_OLD_YAMLCPP)
endif()

pkg_check_modules(ATASMART "libatasmart")

if(SYSTEMD_FOUND)
	set(PID_FILE "/run/thinkfan.pid")
else()
	set(PID_FILE "/var/run/thinkfan.pid")
endif()


#
# Defaults to OFF because libatasmart seems to be horribly inefficient
#
option(USE_ATASMART "Enable reading temperatures from HDDs via S.M.A.R.T" OFF)

#
# Defaults to ON because it seems reasonably fast. The libnvidia-ml.so is
# loaded at runtime, so we don't add a compile-time dependency on the
# proprietary nVidia driver.
#
option(USE_NVML "Get temperatures directly from nVidia GPUs via their proprietary NVML API" ON)

#
# The shiny new YAML config parser. Depends on yaml-cpp.
#
option(USE_YAML "Enable the new YAML-based config format" ON)


option(DISABLE_BUGGER "Disable bug detection, i.e. dont't catch segfaults and unhandled exceptions" OFF)
option(DISABLE_SYSLOG "Disable logging to syslog, always log to stdout" OFF)
option(DISABLE_EXCEPTION_CATCHING "Terminate with SIGABRT on all exceptions, causing a core dump on every error" OFF)


set(SRC_FILES src/thinkfan.cpp src/config.cpp src/drivers.cpp
	src/message.cpp src/parser.cpp src/error.cpp)

if(USE_YAML)
	if(NOT YAML_CPP_FOUND)
		message(FATAL_ERROR "USE_YAML enabled but yaml-cpp not found. Please install yaml-cpp[-devel]!")
	endif()
	set(SRC_FILES ${SRC_FILES} src/yamlconfig.cpp)
endif(USE_YAML)


#
# Set default build type
#
if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Options are: Debug Release RelWithDebInfo MinSizeRel."
		FORCE)
endif(NOT CMAKE_BUILD_TYPE)

add_compile_options(-Wall -std=c++1y)
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -g3 -DDEBUG")


add_executable(thinkfan ${SRC_FILES})

if (PID_FILE)
	target_compile_definitions(thinkfan PRIVATE -DPID_FILE=\"${PID_FILE}\")
endif()
target_compile_definitions(thinkfan PRIVATE -DVERSION="1.2")

# std::condition_variable::wait_for doesn't block if not explicitly linked against libpthread
# https://stackoverflow.com/questions/41394670/c-condition-variable-wait-for-returns-instantly
# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=58929
target_link_libraries(thinkfan PRIVATE ${CMAKE_THREAD_LIBS_INIT})

if(USE_ATASMART)
	if(NOT ATASMART_FOUND)
		message(FATAL_ERROR "USE_ATASMART enabled but libatasmart not found. Please install libatasmart[-devel]!")
	else()
		target_compile_definitions(thinkfan PRIVATE -DUSE_ATASMART)
		target_link_libraries(thinkfan PRIVATE atasmart)
	endif()
endif(USE_ATASMART)

if(USE_NVML)
	target_include_directories(thinkfan PRIVATE "include")
	target_compile_definitions(thinkfan PRIVATE -DUSE_NVML)
	target_link_libraries(thinkfan PRIVATE dl)
endif(USE_NVML)

if(USE_YAML)
	target_compile_definitions(thinkfan PRIVATE -DUSE_YAML)
	target_include_directories(thinkfan PRIVATE ${YAML_CPP_INCLUDE_DIRS})
	target_link_libraries(thinkfan PRIVATE ${YAML_CPP_LIBRARIES})
endif(USE_YAML)

if(SYSTEMD_FOUND)
	target_compile_definitions(thinkfan PRIVATE -DHAVE_SYSTEMD)
endif()

if(DISABLE_BUGGER)
	target_compile_definitions(thinkfan PRIVATE -DDISABLE_BUGGER)
endif(DISABLE_BUGGER)
if(DISABLE_SYSLOG)
	target_compile_definitions(thinkfan PRIVATE -DDISABLE_SYSLOG)
endif(DISABLE_SYSLOG)
if(DISABLE_EXCEPTION_CATCHING)
	target_compile_definitions(thinkfan PRIVATE -DDISABLE_EXCEPTION_CATCHING)
endif(DISABLE_EXCEPTION_CATCHING)


install(TARGETS thinkfan DESTINATION "${CMAKE_INSTALL_SBINDIR}")
install(FILES COPYING README.md examples/thinkfan.yaml DESTINATION "${CMAKE_INSTALL_DOCDIR}")
install(FILES src/thinkfan.1 DESTINATION "${CMAKE_INSTALL_MANDIR}/man1")
install(FILES src/thinkfan.conf.5 DESTINATION "${CMAKE_INSTALL_MANDIR}/man5")

if(SYSTEMD_FOUND)
	configure_file(rcscripts/systemd/thinkfan.service.cmake
		rcscripts/systemd/thinkfan.service)
	install(FILES
		rcscripts/systemd/thinkfan-sleep.service
		rcscripts/systemd/thinkfan-wakeup.service
		"${CMAKE_BINARY_DIR}/rcscripts/systemd/thinkfan.service"
		DESTINATION "${CMAKE_INSTALL_PREFIX}/lib/systemd/system")
	if(NOT EXISTS "/etc/systemd/system/thinkfan.service.d/override.conf")
		install(FILES
			rcscripts/systemd/override.conf
			DESTINATION "/etc/systemd/system/thinkfan.service.d")
	else()
		install(FILES
			rcscripts/systemd/override.conf
			DESTINATION "/etc/systemd/system/thinkfan.service.d"
			RENAME "default.conf")
	endif()
endif(SYSTEMD_FOUND)

if(OPENRC_FOUND)
	configure_file(rcscripts/openrc/thinkfan.cmake
		rcscripts/openrc/thinkfan)
	install(FILES
		"${CMAKE_BINARY_DIR}/rcscripts/openrc/thinkfan"
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
		DESTINATION "/etc/init.d")
endif(OPENRC_FOUND)

=== debian/changelog ===
thinkfan (1.2.1-3~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 16 Jul 2021 14:08:10 -0700

thinkfan (1.2.1-3) unstable; urgency=medium

  * install legacy config manpage (Closes: #982289)
  * document new YAML config and how to convert in NEWS.Debian (Closes: #981699)

 -- Evgeni Golov <evgeni@debian.org>  Sat, 27 Feb 2021 15:03:05 +0100

thinkfan (1.2.1-2) unstable; urgency=medium

  * relicense the appstream metadata as MIT
  * drop old upgrade code for pre-oldstable versions
  * don't install systemd override (Closes: #981242)
  * remove obsolete thinkfan.conf (Closes: #981251)

 -- Evgeni Golov <evgeni@debian.org>  Tue, 02 Feb 2021 21:31:16 +0100

thinkfan (1.2.1-1) unstable; urgency=medium

  * New upstream version (Closes: #961300)
    + Builds with GCC 10 (Closes: #957877)
    + Uses /run by default (Closes: #918899)
    + Includes support for re-init after suspend (Closes: #663619)
    + New config format makes hwmon addressing stable (Closes: #843446)
    + New config example contains "disengaged" line (Closes: #797303)
  * refresh rcscripts-drop-start-check.patch
  * drop cmake-man.patch, applied upstream
  * refresh rcscripts-load-defaults-for-systemd.patch
  * use debhelper-compat 13 and drop dh-systemd dependency (Closes: #958613)
  * add libyaml-cpp-dev to depends
  * update vcs-* fields to salsa
  * use priority: optional
  * Standards-Version: 4.5.1
  * add pkg-config to build-depends
  * add systemd to build-depends
  * update debian/copyright

 -- Evgeni Golov <evgeni@debian.org>  Wed, 27 Jan 2021 21:06:36 +0100

=== debian/control ===
Source: thinkfan
Section: misc
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Evgeni Golov <evgeni@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 12),
               libatasmart-dev,
               libyaml-cpp-dev,
               pkg-config,
               systemd
Standards-Version: 4.5.1
Homepage: https://github.com/vmatare/thinkfan
Vcs-Browser: https://salsa.debian.org/debian/thinkfan
Vcs-Git: https://salsa.debian.org/debian/thinkfan.git

Package: thinkfan
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: simple and lightweight fan control program
 Some hardware has a kind of broken fan-control and lets the fan run
 faster than really needed. Thinkfan will prevent this by controlling
 the fan on its own (the fan speed for each temperature interval can be
 adjusted in the configuration file).
 .
 Originally designed specifically for IBM/Lenovo Thinkpads,
 it supports any kind of system via the sysfs hwmon interface.
 It is designed to eat as little CPU power as possible.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_ATASMART=YES
override_dh_auto_install:
	dh_auto_install
	rm -rf $(CURDIR)/debian/thinkfan/etc/systemd/
	rm $(CURDIR)/debian/thinkfan/usr/share/doc/thinkfan/thinkfan.yaml
	rm $(CURDIR)/debian/thinkfan/usr/share/doc/thinkfan/COPYING
	install -D -m0644 examples/thinkfan.yaml $(CURDIR)/debian/thinkfan/etc/thinkfan.yaml
	install -D -m0755 rcscripts/sysvinit/thinkfan.init $(CURDIR)/debian/thinkfan/etc/init.d/thinkfan
	install -D -m0644 rcscripts/sysvinit/thinkfan.default $(CURDIR)/debian/thinkfan/etc/default/thinkfan

override_dh_installinit:
	dh_installinit --onlyscripts

override_dh_installsystemd:
	# Do not enable the file by default on purpose.
	# The user should enable it only after making sure the configuration is
	# appropriate for his/her computer.
	# This corresponds to START=no in /etc/default/thinkfan
	dh_installsystemd --no-enable

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## thinkfan 1.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,7 @@
 project(thinkfan)
 include(GNUInstallDirs)
+
+set(THINKFAN_VERSION 1.3.1)
 
 cmake_minimum_required(VERSION 3.0)
 
@@ -50,7 +52,7 @@
 option(DISABLE_EXCEPTION_CATCHING "Terminate with SIGABRT on all exceptions, causing a core dump on every error" OFF)
 
 
-set(SRC_FILES src/thinkfan.cpp src/config.cpp src/drivers.cpp
+set(SRC_FILES src/thinkfan.cpp src/config.cpp src/fans.cpp src/sensors.cpp
 	src/message.cpp src/parser.cpp src/error.cpp)
 
 if(USE_YAML)
@@ -78,7 +80,7 @@
 if (PID_FILE)
 	target_compile_definitions(thinkfan PRIVATE -DPID_FILE=\"${PID_FILE}\")
 endif()
-target_compile_definitions(thinkfan PRIVATE -DVERSION="1.2")
+target_compile_definitions(thinkfan PRIVATE -DVERSION="${THINKFAN_VERSION}")
 
 # std::condition_variable::wait_for doesn't block if not explicitly linked against libpthread
 # https://stackoverflow.com/questions/41394670/c-condition-variable-wait-for-returns-instantly
@@ -120,11 +122,15 @@
 	target_compile_definitions(thinkfan PRIVATE -DDISABLE_EXCEPTION_CATCHING)
 endif(DISABLE_EXCEPTION_CATCHING)
 
+configure_file(src/thinkfan.1.cmake thinkfan.1)
+configure_file(src/thinkfan.conf.5.cmake thinkfan.conf.5)
+configure_file(src/thinkfan.conf.legacy.5.cmake thinkfan.conf.legacy.5)
 
 install(TARGETS thinkfan DESTINATION "${CMAKE_INSTALL_SBINDIR}")
 install(FILES COPYING README.md examples/thinkfan.yaml DESTINATION "${CMAKE_INSTALL_DOCDIR}")
-install(FILES src/thinkfan.1 DESTINATION "${CMAKE_INSTALL_MANDIR}/man1")
-install(FILES src/thinkfan.conf.5 DESTINATION "${CMAKE_INSTALL_MANDIR}/man5")
+install(FILES ${CMAKE_BINARY_DIR}/thinkfan.1 DESTINATION "${CMAKE_INSTALL_MANDIR}/man1")
+install(FILES ${CMAKE_BINARY_DIR}/thinkfan.conf.5 DESTINATION "${CMAKE_INSTALL_MANDIR}/man5")
+install(FILES ${CMAKE_BINARY_DIR}/thinkfan.conf.legacy.5 DESTINATION "${CMAKE_INSTALL_MANDIR}/man5")
 
 if(SYSTEMD_FOUND)
 	configure_file(rcscripts/systemd/thinkfan.service.cmake

=== debian/changelog ===
thinkfan (1.3.1-6) unstable; urgency=medium

  * move aliased files from / to /usr (DEP17) (Closes: #1073731)
  * Update copyright data
  * Bump Standards-Version (no changes needed)

 -- Lee Garrett <debian@rocketjump.eu>  Thu, 08 Aug 2024 11:29:32 +0200

thinkfan (1.3.1-5) unstable; urgency=medium

  * The "Greetings from Mini-Debconf Berlin!" release
  * Move package to DEP-14 layout
  * d/control: Remove systemd build-dep (Fixes: #1060540)
  * Unconditionally install sysvinit/openrc/systemd services
  * d/control: fix lintian warning
  * Refresh patches

 -- Lee Garrett <debian@rocketjump.eu>  Thu, 16 May 2024 19:37:01 +0200

thinkfan (1.3.1-4) unstable; urgency=medium

  * Prevent thinkfan and zcfan being installed at the same time,
    as this will cause unpredictable behaviour and possibly hardware damage
    (Closes: #1032310)
  * Fix dep3 headers in two patches
  * Bump Standards-Version (no changes needed)

 -- Lee Garrett <debian@rocketjump.eu>  Fri, 03 Mar 2023 13:41:08 +0100

thinkfan (1.3.1-3) unstable; urgency=medium

  * Remove path from md5sum call
  * d/control: Bump Standards-Version (no changes needed)
  * d/rules: Enable hardening build flags
  * Fix section in man page header
  * Add more lintian overrides
  * Fix FTBFS on RISC-V (Closes: #1017847)
  * d/control: We don't need root to build
  * Update d/copyright
  * Patch systemd unit to have Documentation key
  * Add dep3 headers to all patches

 -- Lee Garrett <debian@rocketjump.eu>  Sun, 15 Jan 2023 00:07:35 +0100

thinkfan (1.3.1-2) unstable; urgency=medium

  * Fix sleep path (Closes: #984911)

 -- Lee Garrett <debian@rocketjump.eu>  Tue, 14 Jun 2022 00:52:08 +0200

thinkfan (1.3.1-1) unstable; urgency=medium

  * Thanks to Evgeni for maintaining this package in the past!
  * Take over maintainership
  * New upstream release (Closes: #1002746)
  * Bump Standards-Version (no changes needed)

 -- Lee Garrett <debian@rocketjump.eu>  Wed, 13 Apr 2022 16:59:53 +0200

thinkfan (1.2.1-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Don't ship an example config in /etc/thinkfan.yaml (Closes: #983727)
  * Don't fail startup by installing broken config (Closes: #981699)
  * Ship example config in /usr/share/doc/thinkfan/examples/

 -- Lee Garrett <debian@rocketjump.eu>  Tue, 28 Sep 2021 18:57:30 +0200

=== debian/control ===
Source: thinkfan
Section: misc
Priority: optional
Maintainer: Lee Garrett <debian@rocketjump.eu>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libatasmart-dev,
               libyaml-cpp-dev,
               pkgconf,
               dh-sequence-movetousr,
#              ^^^^^
# Remove this dependency after trixie and drop 0003-no-usr-lib-systemd.patch
Rules-Requires-Root: no
Standards-Version: 4.7.0.0
Homepage: https://github.com/vmatare/thinkfan
Vcs-Browser: https://salsa.debian.org/debian/thinkfan
Vcs-Git: https://salsa.debian.org/debian/thinkfan.git

Package: thinkfan
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: zcfan
Description: simple and lightweight fan control program
 Some hardware has a kind of broken fan-control and lets the fan run
 faster than really needed. Thinkfan will prevent this by controlling
 the fan on its own (the fan speed for each temperature interval can be
 adjusted in the configuration file).
 .
 Originally designed specifically for IBM/Lenovo Thinkpads,
 it supports any kind of system via the sysfs hwmon interface.
 It is designed to eat as little CPU power as possible.

## thinkfan 2.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,19 @@
-project(thinkfan)
+cmake_minimum_required(VERSION 3.10)
+
+project(thinkfan LANGUAGES CXX)
 include(GNUInstallDirs)
 
-set(THINKFAN_VERSION 1.3.1)
-
-cmake_minimum_required(VERSION 3.0)
+execute_process(
+	COMMAND git describe --tags
+	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+	RESULT_VARIABLE GIT_DESCRIBE_STATUS
+	OUTPUT_VARIABLE THINKFAN_VERSION
+	OUTPUT_STRIP_TRAILING_WHITESPACE
+	ECHO_OUTPUT_VARIABLE
+)
+if(NOT GIT_DESCRIBE_STATUS EQUAL 0)
+	set(THINKFAN_VERSION 2.0.0)
+endif()
 
 # Generate absolute paths or something
 cmake_policy(SET CMP0015 NEW)
@@ -22,6 +32,9 @@
 
 pkg_check_modules(ATASMART "libatasmart")
 
+find_library(LM_SENSORS_LIB NAMES "libsensors.so" "libsensors.so.5")
+find_path(LM_SENSORS_INC NAMES "sensors/sensors.h")
+
 if(SYSTEMD_FOUND)
 	set(PID_FILE "/run/thinkfan.pid")
 else()
@@ -42,6 +55,11 @@
 option(USE_NVML "Get temperatures directly from nVidia GPUs via their proprietary NVML API" ON)
 
 #
+# Defaults to ON.
+#
+option(USE_LM_SENSORS "Get temperatures from LM sensors" ON)
+
+#
 # The shiny new YAML config parser. Depends on yaml-cpp.
 #
 option(USE_YAML "Enable the new YAML-based config format" ON)
@@ -53,11 +71,15 @@
 
 
 set(SRC_FILES src/thinkfan.cpp src/config.cpp src/fans.cpp src/sensors.cpp
+	src/driver.cpp
+	src/hwmon.cpp
+	src/libsensors.cpp
+	src/temperature_state.cpp
 	src/message.cpp src/parser.cpp src/error.cpp)
 
 if(USE_YAML)
 	if(NOT YAML_CPP_FOUND)
-		message(FATAL_ERROR "USE_YAML enabled but yaml-cpp not found. Please install yaml-cpp[-devel]!")
+		message(FATAL_ERROR "USE_YAML enabled but yaml-cpp not found. Please install yaml-cpp-devel (RedHat) or libyaml-cpp-dev (Debian)!")
 	endif()
 	set(SRC_FILES ${SRC_FILES} src/yamlconfig.cpp)
 endif(USE_YAML)
@@ -71,9 +93,8 @@
 		FORCE)
 endif(NOT CMAKE_BUILD_TYPE)
 
-add_compile_options(-Wall -std=c++1y)
+add_compile_options(-Wall)
 set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -g3 -DDEBUG")
-
 
 add_executable(thinkfan ${SRC_FILES})
 
@@ -86,6 +107,8 @@
 # https://stackoverflow.com/questions/41394670/c-condition-variable-wait-for-returns-instantly
 # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=58929
 target_link_libraries(thinkfan PRIVATE ${CMAKE_THREAD_LIBS_INIT})
+
+set_property(TARGET thinkfan PROPERTY CXX_STANDARD 17)
 
 if(USE_ATASMART)
 	if(NOT ATASMART_FOUND)
@@ -102,11 +125,27 @@
 	target_link_libraries(thinkfan PRIVATE dl)
 endif(USE_NVML)
 
+if(USE_LM_SENSORS)
+	if(LM_SENSORS_LIB MATCHES "LM_SENSORS_LIB-NOTFOUND")
+		message(FATAL_ERROR "USE_LM_SENSORS enabled but libsensors not found. Please install libsensors-dev!")
+	elseif(LM_SENSORS_INC MATCHES "LM_SENSORS_INC-NOTFOUND")
+		message(FATAL_ERROR "USE_LM_SENSORS enabled but sensors/sensors.h not found. Please install libsensors-dev!")
+	else()
+		target_compile_definitions(thinkfan PRIVATE -DUSE_LM_SENSORS)
+		target_include_directories(thinkfan PRIVATE ${LM_SENSORS_INC})
+		target_link_libraries(thinkfan PRIVATE ${LM_SENSORS_LIB})
+	endif()
+endif(USE_LM_SENSORS)
+
 if(USE_YAML)
 	target_compile_definitions(thinkfan PRIVATE -DUSE_YAML)
 	target_include_directories(thinkfan PRIVATE ${YAML_CPP_INCLUDE_DIRS})
 	target_link_libraries(thinkfan PRIVATE ${YAML_CPP_LIBRARIES})
 endif(USE_YAML)
+
+if(${CMAKE_SYSTEM_PROCESSOR} STREQUAL "riscv64")
+    target_link_libraries(thinkfan PRIVATE -latomic)
+endif()
 
 if(SYSTEMD_FOUND)
 	target_compile_definitions(thinkfan PRIVATE -DHAVE_SYSTEMD)

=== debian/changelog ===
thinkfan (2.0.0-1) unstable; urgency=medium

  * New upstream version 2.0.0
    - Fix build failure with CMake 4 (Closes: #1113571)
  * Drop 0004-fix-sleep-path.patch (applied upstream)
  * Drop 0005-fix-manpage-section.patch (applied upstream)
  * Drop 0007-systemd-unit.patch (applied upstream)
  * Refresh patches
  * Add libsensors-dev to build dependencies

 -- Lee Garrett <debian@rocketjump.eu>  Mon, 01 Sep 2025 17:54:39 +0200

=== debian/control ===
--- 
+++ 
@@ -5,6 +5,7 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
                libatasmart-dev,
+               libsensors-dev,
                libyaml-cpp-dev,
                pkgconf,
                dh-sequence-movetousr,

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_ATASMART=YES
override_dh_auto_install:
	dh_auto_install
	rm -rf $(CURDIR)/debian/thinkfan/etc/systemd/
	rm $(CURDIR)/debian/thinkfan/usr/share/doc/thinkfan/thinkfan.yaml
	rm $(CURDIR)/debian/thinkfan/usr/share/doc/thinkfan/COPYING
	install -D -m0644 examples/thinkfan.yaml $(CURDIR)/debian/thinkfan/usr/share/doc/thinkfan/examples/thinkfan.yaml
	install -D -m0755 rcscripts/sysvinit/thinkfan.init $(CURDIR)/debian/thinkfan/etc/init.d/thinkfan
	install -D -m0644 rcscripts/sysvinit/thinkfan.default $(CURDIR)/debian/thinkfan/etc/default/thinkfan

override_dh_installinit:
	dh_installinit --onlyscripts

override_dh_installsystemd:
	# Do not enable the file by default on purpose.
	# The user should enable it only after making sure the configuration is
	# appropriate for their computer.
	# This corresponds to START=no in /etc/default/thinkfan
	dh_installsystemd --no-enable

=== debian/watch ===
version=4
opts="uversionmangle=s/_/~/,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%thinkfan-$1.tar.gz%" \
 https://github.com/vmatare/thinkfan/tags \
 (?:.*?/)?v?(\d.*)\.tar\.gz debian uupdate
